package br.ime.usp.mac5855.actions;

import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import br.ime.usp.mac5855.controller.Controller;
import br.ime.usp.mac5855.controller.Output;
import br.ime.usp.mac5855.dao.AvaliacaoDao;
import br.ime.usp.mac5855.db.ConnectionFactory;
import br.ime.usp.mac5855.modelo.Avaliacao;
import br.ime.usp.mac5855.modelo.Visitante;
import br.ime.usp.mac5855.view.ErrorHandler;

@Controller(name = "avaliacao", shouldBeLoggedInAs="administrador")
public class AvaliacaoController extends AbstractCRUD<Avaliacao> {

	public AvaliacaoController() {
		super(new AvaliacaoDao(ConnectionFactory.getCurrentConnection()));
	}

	public String salva(Avaliacao t, Output out, HttpServletRequest request) {
		t.setData(new Date());
		t.setVisitante((Visitante) request.getSession().getAttribute("visitante"));
		
		if (t.getVisitante() == null) {
			ErrorHandler.add("Precisa estar logado como visitante", out);
		}

		return super.salva(t, out);
	}
	
}
