package br.ime.usp.mac5855.actions;

import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import br.ime.usp.mac5855.controller.Controller;
import br.ime.usp.mac5855.controller.Output;
import br.ime.usp.mac5855.dao.ComentarioDao;
import br.ime.usp.mac5855.db.ConnectionFactory;
import br.ime.usp.mac5855.modelo.Comentario;
import br.ime.usp.mac5855.modelo.Visitante;
import br.ime.usp.mac5855.view.ErrorHandler;

@Controller(name = "comentario", shouldBeLoggedInAs="administrador")
public class ComentarioController extends AbstractCRUD<Comentario> {

	public ComentarioController() {
		super(new ComentarioDao(ConnectionFactory.getCurrentConnection()));
	}

	public String salva(Comentario t, Output out, HttpServletRequest request) {
		t.setData(new Date());
		t.setVisitante((Visitante) request.getSession().getAttribute("visitante"));
		
		if (t.getVisitante() == null) {
			ErrorHandler.add("Precisa estar logado como visitante", out);
		}
		
		return super.salva(t, out);
	}
	
}
