package br.ime.usp.mac5855.actions;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.ime.usp.mac5855.controller.Controller;
import br.ime.usp.mac5855.dao.AvaliacaoDao;
import br.ime.usp.mac5855.dao.ComentarioDao;
import br.ime.usp.mac5855.dao.ProgramaDao;
import br.ime.usp.mac5855.db.ConnectionFactory;
import br.ime.usp.mac5855.modelo.Avaliacao;
import br.ime.usp.mac5855.modelo.Comentario;
import br.ime.usp.mac5855.modelo.Visitante;
import br.ime.usp.mac5855.view.ErrorHandler;

@Controller(name = "interacao", shouldBeLoggedInAs = "visitante")
public class InteracaoController {

	public String comenta(Comentario c, HttpServletRequest request) {
		c.setVisitante((Visitante) request.getSession().getAttribute("visitante"));

		if (c.getVisitante() == null) {
			ErrorHandler.add("Precisa estar logado como visitante para postar", request);
		} else {
			ComentarioDao dao = new ComentarioDao(ConnectionFactory.getCurrentConnection());
			dao.salva(c);
		}
		return "redirect:home.detalhes.action?programa.id=" + c.getPrograma().getId();
	}

	/**
	 * Usando AJAX com JSON
	 */
	public String avalia(Avaliacao a, HttpServletRequest request, HttpServletResponse response) throws IOException {
		a.setVisitante((Visitante) request.getSession().getAttribute("visitante"));

		response.setContentType("application/json");
		
		if (a.getVisitante() == null) {
			response.getWriter()
				.println("{status: 'erro', msg: 'Precisa estar logado como visitante para avaliar'}");
		} else {
			try {
				AvaliacaoDao avaliacaoDao = new AvaliacaoDao(ConnectionFactory.getCurrentConnection());
				avaliacaoDao.salva(a);
				
				ProgramaDao programaDao = new ProgramaDao(ConnectionFactory.getCurrentConnection());
				double media = programaDao.busca(a.getPrograma().getId()).getMediaDeAvaliacoes();
				
				response.getWriter()
					.println("{status: 'ok', avaliacaoMedia: '"+media+"'}");
			} catch (Exception e) {
				e.printStackTrace();
				response.getWriter()
					.println("{status: 'erro', msg: 'Algum problema técnico ocorreu, tenta mais tarde'}");
			}
		}
		
		return ""; // sem view
	}

}
