package br.ime.usp.mac5855.dao;

import java.lang.reflect.Field;
import java.sql.ResultSet;

public class Util {

	public static void copyValues(Object instance, ResultSet rs) throws Exception {
		Field [] fields = instance.getClass().getDeclaredFields();
		for(Field field : fields){
			field.setAccessible(true);
			if(canBeSet(field)){							
				field.set(instance, rs.getObject(field.getName()));
			}else if(isDate(field)){
				java.sql.Date date = rs.getDate(field.getName());
				if(date != null){
					field.set(instance, new java.util.Date(date.getTime()));
				}
			}
		}
	}

	
	private static boolean isDate(Field field) {
		return field.getType().getName().indexOf("java.util.Date") >= 0;
	}


	private static boolean canBeSet(Field field) {
		Class<?> type = field.getType();
		return Number.class.isAssignableFrom(type) || type.getName().indexOf("java.lang.String") >= 0;
	}
}
