package br.ime.usp.mac5855.db;

import java.sql.Connection;
import java.util.Date;
import java.util.List;

import br.ime.usp.mac5855.dao.ComentarioDao;
import br.ime.usp.mac5855.dao.ProgramaDao;
import br.ime.usp.mac5855.dao.VisitanteDao;
import br.ime.usp.mac5855.modelo.Comentario;
import br.ime.usp.mac5855.modelo.Programa;
import br.ime.usp.mac5855.modelo.Visitante;


public class TesteDB {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Database.startDatabase();
		
		Connection conn = ConnectionFactory.getConnection();
		
		VisitanteDao dao = new VisitanteDao(conn);
		Visitante v = new Visitante();
		v.setCadastradoEm(new Date());
		v.setEmail("thadeurc@gmail.com");
		v.setNome("Thadeu Russo");
		v.setSenha("123456");
		dao.salva(v);
		
		ProgramaDao pdao = new ProgramaDao(conn);
		Programa p = new Programa();
		p.setDescricao("Futebol");
		p.setNome("Globo Esporte");
		pdao.salva(p);
		
		Comentario com = v.criaComentario(p, "legal!");
		ComentarioDao cdao = new ComentarioDao(conn);
		cdao.salva(com);
		
		
		
		List<Comentario> comentarios = pdao.busca(p.getId()).getComentarios();
		for (Comentario comentario : comentarios) {
			System.out.println(comentario.getDescricao());
			System.out.println(comentario.getPrograma());
			System.out.println(comentario.getData());
			System.out.println(comentario.getVisitante());
		}
		
		cdao.close();
	}

}
