package br.ime.usp.mac5855.jsf;

import javax.faces.application.NavigationHandler;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;

/**
 * PhaseListener que cuida da autorização.
 * O admin precisa estar logado para acessar a página, caso contrário
 * é redirecionado para a tela de login.
 */
public class Autorizacao implements PhaseListener {
	private static final long serialVersionUID = 1749697094176345659L;

	public void afterPhase(PhaseEvent event) {
		FacesContext fc = event.getFacesContext();
		ExternalContext ec = fc.getExternalContext();
		
		Object admin = ec.getSessionMap().get("administrador");
		
		if (admin == null) {
			// redireciona para o login
			NavigationHandler nav = fc.getApplication().getNavigationHandler();
			nav.handleNavigation(fc, null, "login");
			
			// renderiza a pagina
			fc.renderResponse();
		}
	}

	public PhaseId getPhaseId() {
		return PhaseId.RESTORE_VIEW;
	}

	public void beforePhase(PhaseEvent arg0) {
	}
}
