package br.ime.usp.mac5855.modelo;

import java.util.Date;

import br.ime.usp.mac5855.view.Campo;
import br.ime.usp.mac5855.view.Modelo;
import br.ime.usp.mac5855.view.Campo.Tipo;

@Modelo(singular="avaliação", plural="avaliações")
public class Avaliacao implements Identifiable {

	@Campo(titulo="ID", tipo=Tipo.HIDDEN)
	private Long id;
	
	@Campo(titulo="Valor (1 a 10)")
	private Integer valor;
	
	@Campo(titulo="Programa", tipo=Tipo.COMBO)
	private Programa programa;
	
	private Visitante visitante;

	@Campo(titulo="Data",formato="%1$Td/%1$Tm/%1$TY", tipo=Tipo.HIDDEN)
	private Date data = new Date();

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the valor
	 */
	public Integer getValor() {
		return valor;
	}

	/**
	 * @param valor the valor to set
	 */
	public void setValor(Integer valor) {
		if (valor < 1)
			this.valor = 1;
		else if (valor > 10)
			this.valor = 10;
		else
			this.valor = valor;
	}

	/**
	 * @return the data
	 */
	public Date getData() {
		return data;
	}

	/**
	 * @param data the data to set
	 */
	public void setData(Date data) {
		this.data = data;
	}

	/**
	 * @return the visitante
	 */
	public Visitante getVisitante() {
		return visitante;
	}

	/**
	 * @param visitante the visitante to set
	 */
	public void setVisitante(Visitante visitante) {
		this.visitante = visitante;
	}

	/**
	 * @return the programa
	 */
	public Programa getPrograma() {
		return programa;
	}

	/**
	 * @param programa the programa to set
	 */
	public void setPrograma(Programa programa) {
		this.programa = programa;
	}
}
