package br.ime.usp.mac5855.modelo;

import java.util.Date;

import br.ime.usp.mac5855.view.Campo;
import br.ime.usp.mac5855.view.Modelo;
import br.ime.usp.mac5855.view.Campo.Tipo;

@Modelo(singular="exibição", plural="exibições")
public class Exibicao implements Identifiable {

	@Campo(titulo="ID", tipo=Tipo.HIDDEN)
	private Long id;
	
	@Campo(titulo="Início", tipo=Tipo.DATETIME, formato="%1$Td/%1$Tm/%1$TY %1$TH:%1$TM")
	private Date inicio = new Date();
	
	@Campo(titulo="Início", tipo=Tipo.DATETIME, formato="%1$Td/%1$Tm/%1$TY %1$TH:%1$TM")
	private Date fim = new Date();
	
	@Campo(titulo="Programa", tipo=Tipo.COMBO)
	private Programa programa;
	
	@Campo(titulo="Classificação", tipo=Tipo.COMBO)
	private Classificacao classificacao;
	
	@Campo(titulo="Emissora", tipo=Tipo.COMBO)
	private Emissora emissora;

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the inicio
	 */
	public Date getInicio() {
		return inicio;
	}

	/**
	 * @param inicio the inicio to set
	 */
	public void setInicio(Date inicio) {
		this.inicio = inicio;
	}

	/**
	 * @return the fim
	 */
	public Date getFim() {
		return fim;
	}

	/**
	 * @param fim the fim to set
	 */
	public void setFim(Date fim) {
		this.fim = fim;
	}

	/**
	 * @return the programa
	 */
	public Programa getPrograma() {
		return programa;
	}

	/**
	 * @param programa the programa to set
	 */
	public void setPrograma(Programa programa) {
		this.programa = programa;
	}

	/**
	 * @return the classificacao
	 */
	public Classificacao getClassificacao() {
		return classificacao;
	}

	/**
	 * @param classificacao the classificacao to set
	 */
	public void setClassificacao(Classificacao classificacao) {
		this.classificacao = classificacao;
	}

	/**
	 * @return the emissora
	 */
	public Emissora getEmissora() {
		return emissora;
	}

	/**
	 * @param emissora the emissora to set
	 */
	public void setEmissora(Emissora emissora) {
		this.emissora = emissora;
	}
	
	/**
	 * Diz se a exibicao e impropria para menores.
	 * 
	 * @return true se for improprio para menores, false caso contrario.
	 * */
	public boolean isImproprioParaMenores(){
		return this.classificacao != null && this.classificacao == Classificacao.MAIOR_18;
	}
}
