package br.ime.usp.mac5855.modelo;

import java.util.ArrayList;
import java.util.List;

import br.ime.usp.mac5855.view.Campo;
import br.ime.usp.mac5855.view.Modelo;
import br.ime.usp.mac5855.view.Campo.Tipo;

@Modelo(singular="programa", plural="programas")
public class Programa implements Identifiable {

	@Campo(titulo="ID", tipo=Tipo.HIDDEN)
	private Long id;
	
	@Campo(titulo="Nome")
	private String nome;

	@Campo(titulo="Descrição")
	private String descricao;
	
	/* bi-direcionais */
	private List<Comentario> comentarios = new ArrayList<Comentario>();
	
	private List<Avaliacao> avaliacoes = new ArrayList<Avaliacao>();

	private List<Exibicao> exibicoes = new ArrayList<Exibicao>();
	
	/**
	 * @return the exibicoes
	 */
	public List<Exibicao> getExibicoes() {
		return exibicoes;
	}

	/**
	 * @param exibicoes the exibicoes to set
	 */
	public void setExibicoes(List<Exibicao> exibicoes) {
		this.exibicoes = exibicoes;
	}

	
	
	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the nome
	 */
	public String getNome() {
		return nome;
	}

	/**
	 * @param nome the nome to set
	 */
	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the descricao
	 */
	public String getDescricao() {
		return descricao;
	}

	/**
	 * @param descricao the descricao to set
	 */
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}

	/**
	 * @return the comentarios
	 */
	public List<Comentario> getComentarios() {
		return comentarios;
	}

	/**
	 * @param comentarios the comentarios to set
	 */
	public void setComentarios(List<Comentario> comentarios) {
		this.comentarios = comentarios;
	}

	/**
	 * @return the avaliacoes
	 */
	public List<Avaliacao> getAvaliacoes() {
		return avaliacoes;
	}

	/**
	 * @param avaliacoes the avaliacoes to set
	 */
	public void setAvaliacoes(List<Avaliacao> avaliacoes) {
		this.avaliacoes = avaliacoes;
	}

	/**
	 * @return media das avaliacoes
	 * */
	public double getMediaDeAvaliacoes() {
		double quantidade = avaliacoes.size();
		double sum = 0d;
		for (Avaliacao avaliacao : this.avaliacoes) {
			sum += avaliacao.getValor();
		}		
		return sum / (quantidade > 0 ? quantidade : 1);
	}
	
	@Override
	public String toString() {
		return nome;
	}
	
}
