package br.ime.usp.mac5855.modelo;

import java.util.Date;

import br.ime.usp.mac5855.view.Campo;
import br.ime.usp.mac5855.view.Modelo;
import br.ime.usp.mac5855.view.Campo.Tipo;

@Modelo(singular="visitante", plural="visitantes")
public class Visitante implements Identifiable {

	@Campo(titulo="ID", tipo=Tipo.HIDDEN)
	private Long id;
	
	@Campo(titulo="Nome")
	private String nome;

	@Campo(titulo="E-mail")
	private String email;
	
	@Campo(titulo="Senha", tipo=Tipo.PASSWORD)
	private String senha;
	
	@Campo(titulo="Cadastrado em", tipo=Tipo.OUT, formato="%1$Td/%1$Tm/%1$TY")
	private Date cadastradoEm = new Date();
	
	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the nome
	 */
	public String getNome() {
		return nome;
	}

	/**
	 * @param nome the nome to set
	 */
	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * @param email the email to set
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * @return the senha
	 */
	public String getSenha() {
		return senha;
	}

	/**
	 * @param senha the senha to set
	 */
	public void setSenha(String senha) {
		this.senha = senha;
	}

	/**
	 * @return the cadastradoEm
	 */
	public Date getCadastradoEm() {
		return cadastradoEm;
	}

	/**
	 * @param cadastradoEm the cadastradoEm to set
	 */
	public void setCadastradoEm(Date cadastradoEm) {
		this.cadastradoEm = cadastradoEm;
	}

	/**
	 * Cria um comentario do visitante corrente com a 
	 * data atual para o Programa <param>programa</param>,
	 * cujo texto e <param>texto</param>.
	 * 
	 * @param texto
	 * @return Comentario
	 * */
	public Comentario criaComentario(Programa programa, String texto){
		Comentario comentario = new Comentario();
		comentario.setData(new Date());
		comentario.setDescricao(texto);
		comentario.setVisitante(this);
		comentario.setPrograma(programa);
		return comentario;
	}
	
	@Override
	public String toString() {
		return nome;
	}
}
