package br.ime.usp.mac5855.view;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.FIELD)
@Retention(RetentionPolicy.RUNTIME)
public @interface Campo {
	String titulo();
	String formato() default "%s";
	Tipo tipo() default Campo.Tipo.TEXT;
	
	public enum Tipo {
		TEXT, /* input text */ 
		PASSWORD, /* input password */ 
		HIDDEN, /* input hidden */
		DATETIME, /* date time */
		OUT, /* mostrado só na listagem */
		COMBO; /* select */
	}
}

